#include <cstdio>
#include <cstring>
#include <algorithm>
#include <vector>

using namespace std;

vector < pair <long long int, int> > wzorce;

int main ()
{
   int tnum;
   scanf ("%d", &tnum);
//   wzorce.reserve (131072);
   for (int ti = 0; ti < tnum; ti++)
   {
      int pnum = 0; int unum = 0;
      char unames[16][16];
      int convtab[4][4];
      int convtab2[4];
      bool convmask[4];
      fill (convmask, convmask + 4, false);
      
      scanf ("%d", &pnum);
//      printf ("---- test numer %d\n", ti);

      for (int pi = 0; pi < pnum; pi++)
      {
	 int i, unum1 = 0, unum2 = 0;
	 char unit1[16], unit2[16];
	 int uconv;

/*	 scanf ("%*d");
	 scanf ("%s", unit1);
	 scanf ("%*s"); // =
	 scanf ("%d", &uconv);
	 scanf ("%s", unit2);*/
	 scanf ("%*d %s = %d %s", unit1, &uconv, unit2);

	 for (i = 0; i < unum; i++)
	    if (strcmp (unames[i], unit1) == 0)
	    {
	       unum1 = i;
	       break;
	    }
	 if (i == unum) // przeszlismy bez znalezienia w tablicy jednostek
	    unum1 = unum++;

//	 printf ("unit1 = %s\n", unit1);
//	 printf ("unit2 = %s\n", unit2);
	 strcpy (unames[unum1], unit1);
	 
	 for (i = 0; i < unum; i++)
	    if (strcmp (unames[i], unit2) == 0)
	    {
	       unum2 = i;
	       break;
	    }
	 if (i == unum) // przeszlismy bez znalezienia w tablicy jednostek
	    unum2 = unum++;
	 strcpy (unames[unum2], unit2);

	 convtab[pi][0] = unum1; // pierwsza jednostka
	 convtab[pi][1] = unum2; // druga jednostka
	 convtab[pi][2] = uconv; // przelicznik (1 pierwsza = uconv druga)
      }
//      printf ("mamy takie jednostki:\n");
//      for (int i = 0; i < unum; i++)
//	 printf ("%d: %s\n", i, unames[i]);

      convtab2[0] = 1;

      for (int i = 0; i < pnum; ++i) {
	 int i1 = convtab[i][0];
	 int i2 = convtab[i][1];
	 if (i == 0) {
	    convtab2[i1] = convtab[i][2];
	    convtab2[i2] = 1;
	 }
	 if (convmask[i1]) {
	    convtab2[i2] = convtab2[i1];
	    for (int j = 0; j < unum; ++j) {
	       if (convmask[j]) {
		  convtab2[j] *= convtab[i][2];
	       }
	    }
	 } else {
	    convtab2[i1] = convtab[i][2] * convtab2[i2];
	 }
	 convmask[i1] = convmask[i2] = true;
      }
//      printf ("przeliczniki:\n");
//      for (int i = 0; i < unum; i++)
//	 printf ("%s = %d najmniejszych\n", unames[i], convtab2[i]);

      int wnum;
      scanf ("%d", &wnum);
      for (int w = 0; w < wnum; w++)
      {
	 char jednostka[16];
	 int ile;
	 
	 int u = 0;
	 scanf ("%d %s", &ile, jednostka);
	 while (u < unum && strcmp (unames[u], jednostka))
	    u++;
	 if (u == unum)
	    strcpy (unames[unum], jednostka);

	 
	 wzorce.push_back (pair <long long, int> (convtab2[u] * ile, u));
//	 printf ("wzorzec %d = %lld najmniejszych\n", w, wzorce[w].first);
      }
      sort (wzorce.begin (), wzorce.end ());
      int qnum;
      scanf ("%d", &qnum);
      for (int i = 0; i < qnum; i++)
      {
	 int ile, u = 0;
	 
	 char jednostka[16];
	 scanf ("%d %s", &ile, jednostka);
	 while (strcmp (unames[u], jednostka))
	    u++;
	 
	 long long int ile_konw = ile * convtab2[u];
//	 printf ("zapytanie: %lld\n", ile_konw);
	 pair <long long int, int> klucz (ile_konw, 0);
	 vector < pair <long long int, int> > :: iterator res;
	 
	 res = lower_bound (wzorce.begin (), wzorce.end (), klucz);
	 
	 if (res == wzorce.end ())
	    res = res - 1;
	 else if (res->first == ile_konw || res == wzorce.begin ())
	    res = res;
	 else if (std::llabs (res->first - ile_konw) < std::llabs ((res - 1)->first - ile_konw))
	    res = res;
	 else
	    res = res - 1;

	 u = res->second; // jednostka wzorca
	 printf ("%lld %s\n", res->first / convtab2[u], unames[u]);

      }
      wzorce.clear ();
   }

   return 0;
}
